program fieber;
{ UJAs Fever V.1.00  11.10.94: erste durchspielbare Version mit Restart }
{                               Namenseingabe, Fanfare, Computermove     }

uses crt,graph,intuit;

const titel='o   Rear World presents ...    UJAs   F E V E R    V1.00            TP6   o';
      imafil1  ='Fieberwf.ima';       imafil2  ='Fieberth.ima';
      nwurf=3; nzahl=16; maxplayer=5; ynull=324; dy=16;
      voll:FillPatternType=($ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff);

type  augen  =array[1..3] of integer;

      spieler=record
                 x,y      :integer;
                 iscompi  :boolean;
                 id,last  :integer;
                 name     :string;
                 wurf     :array[0..nzahl] of integer;
              end;

      speed  =record
                 w                  :augen;
                 op1,op2            :integer;
                 klammervorn,gebongt:boolean;
              end;
      speedo =array[0..nzahl] of speed;

var wuerfel                        :array[0..2,1..6] of Image;
    block                          :array[0..1] of Image;
    thermo                         :Image;
    igad                           :array[1..36] of Gadget;
    ibord1,ibord2                  :array[1.. 4] of Border;
    xy                             :array[1.. 8] of Koords;
    itext1,itext2,itext3           :array[1..20] of IntuiText;
    gadstring                      :array[1..maxplayer] of strinfo;
    ok,ende,neu                    :Boolean;

    auge                           :augen;
    nzocker                        :integer;
    i,dran,mx,my                   :integer;
    zocker                         :array[1..maxplayer] of spieler;
    liste                          :speedo;


{$i fieber1.inc } { Screenaufbau und Intuition-Strukturen-Initialisierung }
{$i fieber2.inc } { Computermove und Darstellung des Spielverlaufs ------ }
{$i fieber3.inc } { Zug menschlicher Spieler ---------------------------- }
{ ----------------------------------------------------------------------- }

procedure initzockers(n:integer);
var i,j,ox,dx:integer;
begin
dx:=640 div n;
ox:=(dx-80) shr 1;
ox:=ox-dx-(dx shr 3);
for i:=1 to maxplayer do with zocker[i] do begin
   x:=dx*i+ox;
   y:=48;
   id:=i;
   name:='Spieler '+chr(i+48);
end;
end;

{ --- }

begin
for i:=1 to maxplayer do zocker[i].iscompi:=false;
if paramcount>0 then val(paramstr(1),nzocker,i) else nzocker:=1;
if nzocker<maxplayer then begin
   writeln('>>>Der Computer moechte auch mitspielen!');
   inc(nzocker);
   zocker[nzocker].iscompi:=true;
   delay(1000);
end;
if nzocker>maxplayer then begin
   writeln('>>>Habe nur Platz fr ',maxplayer,' Zocker!');
   nzocker:=maxplayer;
   delay(1000);
end;


initscreen(ok);
if ok then begin
   setcolors;
   imagesholen;
   initzockers(nzocker);
   initstructures(nzocker);
end;


if ok then begin
   ende:=false;
   while not ende do begin
      screenzeichnen(nzocker);
      RefreshGadgets(addr(igad[1]));
      for i:=1 to nzocker do with zocker[i] do begin
          for dran:=0 to nzahl do wurf[dran]:=0;
      end;
      neu:=false;
      dran:=0;
      for i:=1 to nzocker do zocker[i].last:=0;
      while not (neu or ende) do begin
          inc(dran); if dran>nzocker then dran:=1;
          if zocker[dran].iscompi
          then compimove(zocker[dran],ende) else spielermove(zocker[dran]);
          if zocker[dran].wurf[0]=2 then begin
             hooray(zocker[dran]);
             gadgetup(addr(igad[1]),i,mx,my);
             ende:=ende or (i=16);
             neu:=true;
          end;
      end; { neu-loop }
   end; { ende-Loop }
   Closegraph;
end;

end.




